/***************************************************************************
// figurka.cpp: implementation of the figurka class.
//
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/

#include "figurka.h"
#include <stdlib.h>
#include "moje_i18n.h"
#include "moje_sdlfunc.h"

// definovanie statickych clenov triedy figurka
int			figurka::dalsiafarba=0;
RGB_farba	figurka::stdFarby[4]={{255,0,0},{0,255,0},{0,0,255},{255,255,0}};
RGB_farba	figurka::stdHFarby[4]={{255,127,127},{127,255,127},{127,127,255},{255,255,127}};
bool		figurka::obrSuNahrate=false;

SDL_Surface* figurka::tc1=NULL;
SDL_Surface* figurka::tc2=NULL;
SDL_Surface* figurka::tc3=NULL;
SDL_Surface* figurka::tc4=NULL;
SDL_Surface* figurka::tc5=NULL;
SDL_Surface* figurka::tl1=NULL;
SDL_Surface* figurka::tl2=NULL;
SDL_Surface* figurka::tl3=NULL;
SDL_Surface* figurka::tl4=NULL;
SDL_Surface* figurka::tl5=NULL;
SDL_Surface* figurka::tp1=NULL;
SDL_Surface* figurka::tp2=NULL;
SDL_Surface* figurka::tp3=NULL;
SDL_Surface* figurka::tp4=NULL;
SDL_Surface* figurka::tp5=NULL;
SDL_Surface* figurka::tv1=NULL;
SDL_Surface* figurka::tv2=NULL;
SDL_Surface* figurka::tv3=NULL;
SDL_Surface* figurka::tv4=NULL;
SDL_Surface* figurka::tv5=NULL;
SDL_Surface* figurka::tcl1=NULL;
SDL_Surface* figurka::tcl2=NULL;
SDL_Surface* figurka::tcl3=NULL;
SDL_Surface* figurka::tcl4=NULL;
SDL_Surface* figurka::tcl5=NULL;
SDL_Surface* figurka::tcp1=NULL;
SDL_Surface* figurka::tcp2=NULL;
SDL_Surface* figurka::tcp3=NULL;
SDL_Surface* figurka::tcp4=NULL;
SDL_Surface* figurka::tcp5=NULL;
SDL_Surface* figurka::tvl1=NULL;
SDL_Surface* figurka::tvl2=NULL;
SDL_Surface* figurka::tvl3=NULL;
SDL_Surface* figurka::tvl4=NULL;
SDL_Surface* figurka::tvl5=NULL;
SDL_Surface* figurka::tvp1=NULL;
SDL_Surface* figurka::tvp2=NULL;
SDL_Surface* figurka::tvp3=NULL;
SDL_Surface* figurka::tvp4=NULL;
SDL_Surface* figurka::tvp5=NULL;
SDL_Surface* figurka::ts=NULL;
SDL_Surface** figurka::tca[8]={&figurka::tc1,&figurka::tc2,&figurka::tc3,&figurka::tc2,&figurka::tc1,&figurka::tc4,&figurka::tc5,&figurka::tc4};
SDL_Surface** figurka::tva[8]={&figurka::tv1,&figurka::tv2,&figurka::tv3,&figurka::tv2,&figurka::tv1,&figurka::tv4,&figurka::tv5,&figurka::tv4};
SDL_Surface** figurka::tla[8]={&figurka::tl1,&figurka::tl2,&figurka::tl3,&figurka::tl2,&figurka::tl1,&figurka::tl4,&figurka::tl5,&figurka::tl4};
SDL_Surface** figurka::tpa[8]={&figurka::tp1,&figurka::tp2,&figurka::tp3,&figurka::tp2,&figurka::tp1,&figurka::tp4,&figurka::tp5,&figurka::tp4};
SDL_Surface** figurka::tcla[8]={&figurka::tcl1,&figurka::tcl2,&figurka::tcl3,&figurka::tcl2,&figurka::tcl1,&figurka::tcl4,&figurka::tcl5,&figurka::tcl4};
SDL_Surface** figurka::tcpa[8]={&figurka::tcp1,&figurka::tcp2,&figurka::tcp3,&figurka::tcp2,&figurka::tcp1,&figurka::tcp4,&figurka::tcp5,&figurka::tcp4};
SDL_Surface** figurka::tvla[8]={&figurka::tvl1,&figurka::tvl2,&figurka::tvl3,&figurka::tvl2,&figurka::tvl1,&figurka::tvl4,&figurka::tvl5,&figurka::tvl4};
SDL_Surface** figurka::tvpa[8]={&figurka::tvp1,&figurka::tvp2,&figurka::tvp3,&figurka::tvp2,&figurka::tvp1,&figurka::tvp4,&figurka::tvp5,&figurka::tvp4};
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

figurka::figurka()
{
	farba=stdFarby[dalsiafarba];
	Hfarba=stdHFarby[dalsiafarba];
	if(++dalsiafarba>=4)dalsiafarba=0;
	hra=nehra;
	rychlost=16;
	pohybLeft=false;
	pohybRight=false;
	pohybUp=false;
	pohybDown=false;
	pohybX=0;
	pohybY=0;
	poziciaX.hodnota=0;
	poziciaY.hodnota=0;
	anim=0;
	tanim=0;
	lastanimobr=tc1;
	body=0;
	sadnut=0;
	sedi=0;
	nicneroby=0;
	sadnutsi=0;
	if(!obrSuNahrate) fprintf(stderr,i18n("Graphic files for class \"figurka\" are not loaded!\n"));
}

figurka::~figurka()
{

}

SDL_Surface *figurka::animobr(bool next)
{

	if(next)
	{
		if(++anim>=8) anim=0;
		if(nicneroby) {sadnutsi++;}else {sadnutsi=0;sadnut=0;};
		if(sadnutsi>100 && !(sadnut>0 || sedi)) sadniSi();
		if(sadnut>0) {sadnut--;};
	}
	sedi=0;
	nicneroby=0;

	if(pohybDown)
	{
		if(pohybLeft)
		{

			if(tanim!=6) {anim=1;tanim=6;};
			lastanimobr = *tcla[anim];
			return lastanimobr;
		}else
		if(pohybRight)
		{
			if(tanim!=4) {anim=1;tanim=4;};
			lastanimobr = *tcpa[anim];
			return lastanimobr;
		}else
		{
			if(tanim!=5) {anim=1;tanim=5;};
			lastanimobr = *tca[anim];
			return lastanimobr;
		}
	}else
	if(pohybUp)
	{
		if(pohybLeft)
		{
			if(tanim!=8) {anim=1;tanim=8;};
			lastanimobr = *tvla[anim];
			return lastanimobr;
		}else
		if(pohybRight)
		{
			if(tanim!=2) {anim=1;tanim=2;};
			lastanimobr = *tvpa[anim];
			return lastanimobr;
		}else
		{
			if(tanim!=1) {anim=1;tanim=1;};
			lastanimobr = *tva[anim];
			return lastanimobr;
		}
	}else
	if(pohybLeft)
	{
		if(tanim!=7) {anim=1;tanim=7;};
		lastanimobr = *tla[anim];
		return lastanimobr;
	}else
	if(pohybRight)
	{
		if(tanim!=3) {anim=1;tanim=3;};
		lastanimobr = *tpa[anim];
		return lastanimobr;
	}
	//ak sa sem dostanem tak panacik cic neroby
	nicneroby=1;

	if(sadnut)
	{//prva faza sadnutia si
		tanim=9;
		lastanimobr=tc1;
		return lastanimobr;
	}
	
	//tanim=0;
	switch(tanim)
	{
	case 1:
		lastanimobr = tv1;
		break;
	case 2:
		lastanimobr = tvp1;
		break;
	case 3:
		lastanimobr = tp1;
		break;
	case 4:
		lastanimobr = tcp1;
		break;
	case 5:
		lastanimobr = tc1;
		break;
	case 6:
		lastanimobr = tcl1;
		break;
	case 7:
		lastanimobr = tl1;
		break;
	case 8:
		lastanimobr = tvl1;
		break;
	case 9:
		lastanimobr = ts;
		sedi=1;
		break;
	default:
			lastanimobr = tc1;
	}
	return lastanimobr;
}

int figurka::nahrajObrazky()
{
	if(obrSuNahrate)
	{
		return 0;
	}

	int ret=0;
    ret |= myLoadBmp(tc1,"tnc1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tc2,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tc3,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tc4,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tc5,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tl1,"tnl1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tl2,"tnl3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tl3,"tnl3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tl4,"tnl5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tl5,"tnl5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tp1,"tnp1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tp2,"tnp3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tp3,"tnp3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tp4,"tnp5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tp5,"tnp5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tv1,"tnh1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tv2,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tv3,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tv4,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tv5,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcl1,"tnc1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcl2,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcl3,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcl4,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcl5,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcp1,"tnc1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcp2,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcp3,"tnc3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcp4,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tcp5,"tnc5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvl1,"tnh1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvl2,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvl3,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvl4,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvl5,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvp1,"tnh1.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvp2,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvp3,"tnh3.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvp4,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(tvp5,"tnh5.bmp",1,data_dir"mbeh.dat");
    ret |= myLoadBmp(ts,"tns.bmp",1,data_dir"mbeh.dat");
	obrSuNahrate=!ret;

	return ret;
}

void figurka::sadniSi()
{
	sadnut=5;
}
