/***************************************************************************
                          mbeh_struktury.h  -  description
                             -------------------
    begin                : Mon Jul 29 2002
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/


#ifndef MBEH_STRUKTURY
#define MBEH_STRUKTURY

#include <SDL/SDL.h>

enum VecPolicka {prazdne_policko=0,neprechodne_policko=0x7f,chyba_policko=255};
enum figurkaHra {nehra=0,clovek,pocitac,siet};
enum akypredmet {predmet_nic=0,predmet_zmrzlinaA,predmet_zmrzlinaB,predmet_zmrzlinaC,predmet_zmrzlinaV,predmet_nanuk/*,predmet_zly,predmet_spomalenie=predmet_zly*/,predmet_pocet};//prvy zly predmet ma hodnotu rovnaku ako predmet_zly aby polozka predmet_zly neovplyvnila predmet_pocet
enum ztagobsah {ztag_figurka,ztag_predmet,ztag_pocet};
enum akystav {stav_uvod,stav_hrasa};
enum pause_prikaz {pause_stop,pause_run,pause_flip};
enum obtiaznost_hry {obtiaz_min, obtiaz_a=obtiaz_min, obtiaz_b, obtiaz_c, obtiaz_max=obtiaz_c, obtiaz_default=obtiaz_b};
struct zTag
{
	int cislo;
	bool obsadene;
	ztagobsah obsah;
};

/*struct RGB_farba
{
	Uint8 r;
	Uint8 g;
	Uint8 b;
};*/
typedef SDL_Color RGB_farba;

#define PPX_DETAIL 4
#define PPO_DETAIL 9
#define STRED_POLICKA  (1<<(PPO_DETAIL-1))		// pocet bodov od kraja policka do stredu(polovica policka v bodoch)
#define VELKOST_POLICKA (1<<(PPO_DETAIL-PPX_DETAIL)) //velkost v pixeloch na osi x
#define MIN_VZDIALENOST (VELKOST_POLICKA>>1)		//16

struct poziciaPixelX
	{
		Uint16 detail :PPX_DETAIL;
		Sint16 pixel :16-PPX_DETAIL;
	};

struct poziciaPixelY
	{
		Uint16 detail :PPX_DETAIL+1;
		Sint16 pixel :16-1-PPX_DETAIL;
	};

struct poziciaPolicko
	{
		Uint16 detail :PPO_DETAIL;
		Sint16 policko :16-PPO_DETAIL;
	};
	
union pozicia
{
	Sint16 hodnota;
	poziciaPixelX hodnotaPixelX;
	poziciaPixelY hodnotaPixelY;
	poziciaPolicko hodnotaPolicko;
	Sint16 operator = (Sint16 h) {hodnota=h;return h;}; //ak bude premennej typu pozicia priradena pomocou = hodnota typu Sint16 bude naplnena premenna hodnota
	operator Sint16 () {return hodnota;};	//premenna typu pozicia (ak sa k nej bude pristupovat ako k Sint16) vracat hodnotu hodnota.
};

struct m_bod
{
	pozicia poziciaX;
	pozicia poziciaY;
//	m_bod &operator=(m_bod&) ;//aj implicitny operator fungoval v linuxe dobre ?
};

struct m_kruh : public m_bod
{
	int polomer;
};

struct predmet : public m_bod
{
//	pozicia poziciaX;
//	pozicia poziciaY;
	akypredmet aky;
	int timeleft;
	predmet() {aky=predmet_nic;};
	int tick() 
	{
		if(timeleft<=0) 
		{
			//aky=nic;
			end();
		}else
		{
			timeleft--;
		}
		return timeleft;
	};
	void end()
	{
		aky=predmet_nic;
		timeleft=0;
	};
	operator akypredmet () {return aky;};
};

#endif // MBEH_STRUKTURY 
 
