/***************************************************************************
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/

#include "moje_DAT.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "bzip2/bzlib.h"
#include "moje_i18n.h"

int readFromDAT(const char *datfile, const char * file, void * &mem, long &size)
{
	//TODO: osetrit poriadne run time chyby!!!!!!!!
	//DONE?				
	FILE * dfp;
	dfp = fopen(datfile,"rb");
	if(dfp==NULL) 
	{
		mem=NULL;
		fprintf(stderr, i18n("Couldn't open DAT file %s for reading."), datfile);
		return 1;//navrat s chybou
	}
	char cfile[256]="";
	long cfl=0;
	int comprimovany=0;
	long compfl=0;
	int ret=0;
	do
	{
		fseek(dfp,compfl,SEEK_CUR );
		//TODO: !!! ten feof niako nefunguje, lebo ak data nenajdem v subore tak slucka nevie skonci
		//DONE
//		if(feof(dfp)) {ret=1;goto end;};//navrat s chybou
		if(fscanf(dfp,"%[^\n]s",cfile)==EOF) {ret=1;goto end;};//navrat s chybou
		fseek(dfp,1,SEEK_CUR );
		fscanf(dfp,"%ld",&cfl);
//		int a=ftell(dfp);
		if(cfl<0) {ret=1;goto end;};//ak nacita niaku hovadinu//navrat s chybou
		fseek(dfp,1,SEEK_CUR );
		fscanf(dfp,"%d",&comprimovany);
		fseek(dfp,1,SEEK_CUR );
		fscanf(dfp,"%ld",&compfl);
		if(compfl<0) {ret=1;goto end;};//ak nacita niaku hovadinu//navrat s chybou
		fseek(dfp,1,SEEK_CUR );
	}while(strcmp(cfile,file)!=0);

	mem=malloc(cfl);
	if(mem==NULL)
	{
		fprintf(stderr, i18n("Insufficient memory available for data from DAT file %s.\n"), datfile);
		ret = 1;//navrat s chybou
		goto end;
	}

	
	if(comprimovany)
	{
		char mode[10];
		int len;
		BZFILE *BZ2fp_r = NULL;
		mode[0]='r';
		mode[1] = '\0';
		fflush(dfp);//potrebne v linuxe aby sa spravne nastavyli ukazovatel pozicie v subore pred citanim suboru pomocou BZ
		if((BZ2fp_r = BZ2_bzdopen(fileno(dfp),mode))==NULL)
		{
			fprintf(stderr,"can't bz2openstream\n");
			ret=1;
			goto end;
		}
		len=BZ2_bzread(BZ2fp_r,mem,cfl);
		if(len!=cfl)
		{
			int er;
			fprintf(stderr,"bz2 read error %s\n",BZ2_bzerror(BZ2fp_r,&er));
		};
		BZ2_bzclose(BZ2fp_r);
	}else
	{//bez kompresie
		fread(mem,1,cfl,dfp);
	};
	size=cfl;

end:
	fclose(dfp);
	return ret;
}
